<HTML>
<HEAD>
<!-- This HTML file has been created by texi2html 1.54
     from suif1.texi on 28 April 1999 -->

<TITLE>The SUIF Version 1 Library - Call-By-Ref Annotes</TITLE>
<link href="suif1_77.html" rel=Next>
<link href="suif1_75.html" rel=Previous>
<link href="suif1_toc.html" rel=ToC>

</HEAD>
<BODY>
<p>Go to the <A HREF="suif1_1.html">first</A>, <A HREF="suif1_75.html">previous</A>, <A HREF="suif1_77.html">next</A>, <A HREF="suif1_113.html">last</A> section, <A HREF="suif1_toc.html">table of contents</A>.
<P><HR><P>


<H3><A NAME="SEC76" HREF="suif1_toc.html#TOC76">Call-By-Reference Annotations</A></H3>
<P>
<A NAME="IDX566"></A>
<A NAME="IDX567"></A>

</P>
<P>
Fortran and other languages pass procedure parameters by reference but
SUIF uses call-by-value.  To implement call-by-reference parameters,
SUIF passes pointers to the actual parameters and then dereferences
those pointers when the formal parameters are used.  While this is
perfectly adequate for many compiler passes, the pointer dereferences
are difficult to handle in some high-level Fortran passes.  The SUIF
Fortran mode automatically converts the code to make it appear that the
parameters are passed by reference.  The library uses two predefined
annotations to implement this.

</P>
<DL COMPACT>

<DT><CODE>k_call_by_ref</CODE>
<DD>
<A NAME="IDX568"></A>
The Fortran front-end puts this annotation on pointer types that are
used to implement call-by-reference parameter passing.  The library uses
this to detect parameters that should be modified when converting to
Fortran mode.  This annotation has no data on its <CODE>immed</CODE> list.

<DT><CODE>k_orig_type</CODE>
<DD>
<A NAME="IDX569"></A>
While in Fortran mode, the types of the call-by-reference parameters are
temporarily replaced.  The <CODE>orig_type</CODE> annotations are attached
to the parameter variables to record their original types.  The
<CODE>immed</CODE> list contains a single entry, the original pointer type of
the parameter.  These annotations are never written to the output files.
</DL>

<P><HR><P>
<p>Go to the <A HREF="suif1_1.html">first</A>, <A HREF="suif1_75.html">previous</A>, <A HREF="suif1_77.html">next</A>, <A HREF="suif1_113.html">last</A> section, <A HREF="suif1_toc.html">table of contents</A>.
</BODY>
</HTML>
